<%--************************************Essential JSP settings. to be used through out the page ********************************--%>
<c:set var="bookingComponent" value="${bookingInfo.bookingComponent}" scope="request" />
<c:choose>
   <c:when test="${bookingComponent.totalAmount.currency.currencyCode=='GBP'}">
        <c:set var="currencySymbol" value="&euro;" scope="request"/>
        <c:set var="currencySymbolUnicode" value="\u00A3"/>
   </c:when>
   <c:when test="${bookingComponent.totalAmount.currency.currencyCode=='EUR'}">
        <c:set var="currencySymbol" value="&euro;" scope="request"/>
        <c:set var="currencySymbolUnicode" value="\u20AC"/>
   </c:when>
   <c:otherwise>
        <c:set var="currencySymbol" value="${bookingComponent.totalAmount.currency.currencyCode}" scope="request"/>
   </c:otherwise>
</c:choose>

<c:set var="visiturl" value="yes" scope="session" />
<c:set var="clientapp" value="${bookingComponent.clientApplication.clientApplicationName}"/>
<c:set var="clientDomainURL" value="${bookingComponent.clientDomainURL}" scope="request"/>


<c:if test="${bookingComponent.totalAmount.currency.currencyCode=='GBP'}">
<%
				String cardChargePercent = com.tui.uk.config.ConfReader.getConfEntry("NEWSKIESM.GBP.cardChargePercent" , "");
                pageContext.setAttribute("cardChargePercent", cardChargePercent, PageContext.REQUEST_SCOPE);
%>
</c:if>
<c:if test="${bookingComponent.totalAmount.currency.currencyCode=='EUR'}">
<%
                String cardChargePercent= com.tui.uk.config.ConfReader.getConfEntry("NEWSKIESM.EUR.cardChargePercent" , "");
                pageContext.setAttribute("cardChargePercent", cardChargePercent, PageContext.REQUEST_SCOPE);
%>
</c:if>
<c:if test="${bookingComponent.totalAmount.currency.currencyCode=='GBP'}">
<%
    String creditCardChargeDetails = com.tui.uk.config.ConfReader.getConfEntry("NEWSKIESM.GBP.cardChargeDetails" , "");
    pageContext.setAttribute("creditCardChargeDetails", creditCardChargeDetails, PageContext.REQUEST_SCOPE);
%>
</c:if>
<c:if test="${bookingComponent.totalAmount.currency.currencyCode=='EUR'}">
<%
    String creditCardChargeDetails = com.tui.uk.config.ConfReader.getConfEntry("NEWSKIESM.EUR.cardChargeDetails" , "");
    pageContext.setAttribute("creditCardChargeDetails", creditCardChargeDetails, PageContext.REQUEST_SCOPE);
%>
</c:if>

<%
    String debitCardChargeDetails = com.tui.uk.config.ConfReader.getConfEntry("debitCardChargeDetails" , "");
    pageContext.setAttribute("debitCardChargeDetails", debitCardChargeDetails, PageContext.REQUEST_SCOPE);
%>

<script type="text/javascript">
  var clientApp = "<c:out value='${clientapp} '/>";
  var clientDomainURL = "<c:out value='${clientDomainURL}'/>";
  var tomcatInstance= "&tomcat=<c:out value='${param.tomcat}' />" ;
  var token = "<c:out value='${param.token}' />" ;
  var newHoliday  = "<c:out value='${bookingInfo.newHoliday}'/>";
  var cardChargePercent = '<c:out value="${cardChargePercent}"/>' ;
  var creditCardChargeDetails = '<c:out value="${creditCardChargeDetails}" />';
  var debitCardChargeDetails = '<c:out value="${debitCardChargeDetails}" />';

<%----------------------Central payment object for using thru out the page----------------------------%>
  var PaymentInfo = {

  totalAmount :"<c:out value='${bookingComponent.totalAmount.amount}'/>",
  payableAmount : "<c:out value='${bookingComponent.payableAmount.amount}'/>",

  calculatedPayableAmount : "<c:out value='${bookingInfo.calculatedPayableAmount.amount}'/>",
  calculatedTotalAmount : "<c:out value='${bookingInfo.calculatedTotalAmount.amount}'/>",
  firstDepositAmount: "<c:out value='${bookingInfo.calculatedTotalAmount.amount}'/>",

  maxCardChargeAmount : "<c:out value='${bookingComponent.maxCardCharge}'/>",

  calculatedDiscount : "<c:out value='${bookingInfo.calculatedDiscount.amount}'/>",

  selectedCardType : null,

  currencySymbol : "<c:out value='${currencySymbolUnicode}' escapeXml='false'/>"
  };
  PaymentInfo.selectedCardType = null;
  PaymentInfo.partialPaymentAmount = null;
  <c:if test="${(bookingComponent.accommodationSummary.accommodationInventorySystem== 'HOPLA_THM' || bookingComponent.accommodationSummary.accommodationInventorySystem== 'HOPLA_PEG') && bookingComponent.accommodationSummary.prepay != 'true'}">
  PaymentInfo.payableAmount  = '<c:out value="${bookingInfo.calculatedPayableAmount.amount}"/>';
  PaymentInfo.partialPaymentAmount = 'true';
  </c:if>

  PaymentInfo.chargePercent = 0.0;

  if(StringUtils.trim(PaymentInfo.calculatedDiscount)=="")
  {
    PaymentInfo.calculatedDiscount = 0.0;
  }
  if(PaymentInfo.maxCardChargeAmount == "")
  {
     PaymentInfo.maxCardChargeAmount = null  ;
  }
<%-----------------*****Central payment object for using thru out the page*****-----------------------%>

<%----------------------Card Charge related config ---------------------------------------------------%>

  var cardChargeMap = new Map();
  cardChargeMap.put('', 0);
  cardChargeMap.put(null, 0);

   <c:forEach var="cardCharges" items="${bookingInfo.cardChargeMap}">
     cardChargeMap.put('<c:out value="${cardCharges.key}"/>', '<c:out value="${cardCharges.value}"/>');
   </c:forEach>
<%-----------------*****END Card Charge related config *****------------------------------------------%>

var bookingConstants = {FULL_COST:"fullCost", TOTAL_CLASS:"total"};

  <%-------------------------------Deposit component related config-------------------------------------------------%>
  var depositAmountsMap = new Map();
  <c:forEach var="depositComponent" items="${bookingComponent.depositComponents}" varStatus="status">
    depositAmountsMap.put('<c:out value="${depositComponent.depositType}"/>', StringUtils.trim('<c:out value="${depositComponent.depositAmount.amount}"/>'));
    <c:if test="${status.first}">
      PaymentInfo.firstDepositAmount = '<c:out value="${depositComponent.depositAmount.amount}"/>';
    </c:if>
  <%---------------------Variables for displaying outstanding balance and due date in the deposit options section.----%>
  <c:if test="${depositComponent.depositType == 'deposit'}">
   <fmt:formatNumber var="outstandingBalance" value="${depositComponent.outstandingBalance.amount}" type="number" maxFractionDigits="2" minFractionDigits="2" scope="request"/>
   <fmt:formatDate var="outstandingBalanceDueDate" value="${depositComponent.depositDueDate}" pattern="EE dd MMM yyyy" scope="request"/>
   <fmt:formatNumber var="outstandingBalanceCardCharge" value="${depositComponent.outstandingBalanceCardCharge.amount}" type="number" maxFractionDigits="2" minFractionDigits="2" scope="request"/>
  </c:if>
  <c:if test="${depositComponent.depositType == 'fullCost'}">
    <fmt:formatNumber var="applicableCardChargeForTotalAmount" value="${depositComponent.applicableCardCharge.amount}" type="number" maxFractionDigits="2" minFractionDigits="2" scope="request"/>
    <%------------------Logic added for checking if the deposit options are present or not.Based on the value of this variable either fullPayment or paymentOtions jspf will be rendered.-------------------------------%>
    <c:set var="depositOptionsPresent" scope="request">
     <c:choose>
      <c:when test="${fn:length(bookingComponent.depositComponents) == 1}">false</c:when>
      <c:otherwise>true</c:otherwise>
     </c:choose>
    </c:set>
    <%------------------End of the logic for checking if the deposit options are present or not.------------------------%>
  </c:if>

  <c:if test="${depositComponent.defaultDepositTypeToBeSelected == 'true'}">
     PaymentInfo.depositType = '<c:out value="${depositComponent.depositType}"/>';
     <fmt:formatNumber var="selectedDepositAmount" value="${depositComponent.depositAmount.amount}" type="number" maxFractionDigits="2" minFractionDigits="2"  scope="request" groupingUsed="false"/>
     <fmt:formatNumber var="applicableCardChargeForSelectedAmount" value="${depositComponent.applicableCardCharge.amount}" type="number" maxFractionDigits="2" minFractionDigits="2"  scope="request" groupingUsed="false"/>
     <fmt:formatNumber var="applicableDebitCardChargeForSelectedAmount" value="${depositComponent.applicableDebitCardCharge.amount}" type="number" maxFractionDigits="2" minFractionDigits="2" scope="request" groupingUsed="false"/>
  </c:if>

  </c:forEach>
  depositAmountsMap.put('fullCost', 1*PaymentInfo.totalAmount  - 1*PaymentInfo.calculatedDiscount);
  <%-------------------------------End of Deposit component related config---------------------------------------%>
<%-- logic for total amount updation with credit card charge--%>

<%--End of logic for total amount updation with credit card charge --%>
  var threeDCards = new Map();
  <c:forEach var="threeDCards" items="${bookingInfo.payDescription}">
      threeDCards.put("<c:out value="${threeDCards.key}"/>","<c:out value="${threeDCards.value}"/>");
  </c:forEach>

  $(document).ready(function(){

			var errorMap = {
			    //On submit error messages
			   	firstnameSubmitErrorrequired:"Please enter a First Name",
			    surnameSubmitErrorrequired:"Please enter a Surname",
				houseNameSubmitErrorrequired: "Please enter your House Name/No",
				addressLine1SubmitErrorrequired: "Please enter a Street Address",
				citySubmitErrorrequired: "Please enter a Town/City",
				postCodeSubmitErrorrequired_postcode: "Please enter a Post Code",
				dayTimePhoneSubmitErrorrequired: "Please enter a Main Phone No",
				emailAddressSubmitErrorrequired: "Please enter an Email Address",
				confirmEmailAddressSubmitErrorrequired: "Please confirm your Email Address",
				emailAddressSubmitErrormatch: "The email addresses do not match",
				confirmEmailAddressSubmitErrormatch: "The email addresses do not match",
				cardTypeSubmitErrorrequired: "Please select a Card Type",
				expiryDateYYSubmitErrorrequired: "Please enter an Expiry Date",
				expiryDateMMSubmitErrorrequired: "Please enter an Expiry Date",
				cardNumberSubmitErrorrequired: "Please enter your Card Number",
				cardNameSubmitErrorrequired: "Please enter Name as it appears on the Card",
				securityCodeSubmitErrorrequired: "Please enter a Security Code",
				cardHouseNameSubmitErrorrequired: "Please enter your House Name/No",
				cardAddress1SubmitErrorrequired: "Please enter a Street Address",
				cardTownCitySubmitErrorrequired: "Please enter a Town/City",
				cardPostCodeSubmitErrorrequired_cardpostcode: "Please enter a Post Code",
				countrySubmitErrorrequired: "Please select a Country",
				cardcountrySubmitErrorrequired: "Please select a Country",
				tourOperatorTermsAcceptedSubmitErrorrequired: "Please confirm you have read and accept the Terms & Conditions and Privacy Policy ",
				
				
				
				houseNameBlurErrorrequired: "Please enter your House Name/No",
				addressLine1BlurErrorrequired: "Please enter a Street Address",
				//addressLine2BlurErrorrequired: "Please enter a Street Address2"
				cityBlurErrorrequired: "Please enter a Town/City",
				postCodeBlurErrorrequired: "Please enter a valid Post Code",
				dayTimePhoneBlurErrorrequired: "Please enter a Main Phone No",
				emailAddressBlurErrorrequired: "Please enter an Email Address",
				confirmEmailAddressBlurErrorrequired: "Please confirm your Email Address",
				cardTypeBlurErrorrequired: "Please select a Card Type",
				expiryDateYYBlurErrorrequired: "Please enter an Expiry Date",
				expiryDateMMBlurErrorrequired: "Please enter an Expiry Date",
				cardNumberBlurErrorrequired: "Please enter your Card Number",
				cardNameBlurErrorrequired: "Please enter Name as it appears on the Card",
				securityCodeBlurErrorrequired: "Please enter a Security Code",
				cardHouseNameBlurErrorrequired: "Please enter your House Name/No",
				cardAddress1BlurErrorrequired: "Please enter a Street Address",
				cardTownCityBlurErrorrequired: "Please enter a Town/City",
				cardPostCodeBlurErrorrequired: "Please enter a valid Post Code",
				countryBlurErrorrequired: "Please select a Country",
				cardcountryBlurErrorrequired: "Please select a Country",
				tourOperatorTermsAcceptedBlurErrorrequired: "Please confirm you have read and accept the Terms & Conditions and Privacy Policy ",

				//On blur error messages
				firstnameBlurErroralpha:"Please enter a valid First Name",
			    surnameBlurErroralpha:"Please enter a valid Surname",
				houseNameBlurErroralphanumericspec: "Please enter a valid House Name/No",
				addressLine1BlurErroralpha: "Please enter a valid Street Address",
				addressLine2BlurErroralpha: "Please enter a valid Street Address",
				cityBlurErroralpha: "Please enter a valid Town/City",
				countyBlurErroralpha: "Please enter a valid County",
				postCodeBlurErrorpostcode: "Please enter a valid Post Code",
				postCodeOptionalBlurErroralphanumeric: "Please enter a valid Post Code",
				dayTimePhoneBlurErrorphonenumber: "Please enter a valid Phone Number",
				mobilePhoneBlurErrorphonenumber: "Please enter a valid Phone Number",
				emailAddressBlurErroremail: "Please enter a valid Email Address",
				confirmEmailAddressBlurErroremail: "Please enter a valid Confirm Email Address",
				cardNumberBlurErrorcardnumber: "Please check your Card Number",
				cardNameBlurErroralpha: "Please enter a valid name on Card",
				expiryDateYYBlurErrorexpirydate: "Expiry Date - Has The Card Expired?",
				expiryDateMMBlurErrorexpirydate: "Expiry Date - Has The Card Expired?",
				securityCodeBlurErrorsecuritycode: "Please enter a valid Security Code",
				issueNumberBlurErrornumeric:"Please enter a valid Issue Number",
				cardHouseNameBlurErroralphanumericspec: "Please enter a valid House Name/No",
				cardAddress1BlurErroralpha: "Please enter a valid Street Address",
				cardAddress2BlurErroralpha: "Please enter a valid Street Address",
				cardTownCityBlurErroralpha: "Please enter a valid Town/City",
				cardPostCodeBlurErrorcardpostcode: "Please enter a valid Post Code",				
				cardCountyBlurErroralpha:"Please enter a valid County",

                //top error messages for server side validation errors
				houseNameTopServerError: "House Name/No",
				addressLine1TopServerError: "Street Address",
				cityTopServerError: "Town/City",
				countyTopServerError: "County",
				postCodeTopServerError: "Post Code",
				dayTimePhoneTopServerError: "Telephone Number",
				mobilePhoneTopServerError: "Phone Number",
				emailAddressTopServerError: "Email Address",
				cardHouseNameTopServerError: "CardHolder House Name/No",
				cardAddress1TopServerError: "CardHolder Street Address",
				cardTownCityTopServerError: "CardHolder Town/City",
				cardPostCodeTopServerError: "CardHolder Post Code",
				countryTopServerError: "Country",
				cardcountryTopServerError: "CardHolder Country",
                titleTopServerError:"Passenger Title",
                cardCountyTopServerError:"CardHolder County",

                // Field specific error messages
				houseNameServerError: "Please enter a valid House Name/No",
				addressLine1ServerError: "Please enter a valid Street Address",
				cityServerError: "Please enter a valid Town/City",
				countyServerError: "Please enter a valid County",
				postCodeServerError: "Please enter a valid Post Code",
				dayTimePhoneServerError: "Please enter a valid Phone Number",
				mobilePhoneServerError: "Please enter a valid Phone Number",
				emailAddressServerError: "Please enter a valid Email Address",
				confirmEmailAddressServerError: "Please enter a valid Email Address",
				cardHouseNameServerError: "Please enter a valid House Name/No",
				cardAddress1ServerError: "Please enter a valid Street Address",
				cardTownCityServerError: "Please enter a valid Town/City",
				cardPostCodeServerError: "Please enter a valid Post Code",
				countryServerError: "Please select a Country",
				cardcountryServerError: "Please select a Country",
				//cardCountyServerError:"CardHolder County",
			    titleServerError:"Passenger Title"
			};



            stickyOverlay.threeDOverlay();
			stickyOverlay.summaryPanelOverlay();
			//Server side error mapping.
			<c:if test="${not empty bookingInfo.errorFields}">
			<c:forTokens var="errorField" items="foreName|houseName|addressLine1|addressLine2|city|postCode|county|dayTimePhone|emailAddress|title|country|cardcountry" delims="|" >
               <c:if test="${fn:containsIgnoreCase(bookingInfo.errorFields,errorField)}">
			      var errorField = "<c:out value='${errorField}' escapeXml='false'/>";
                  //Convert Top Text first char to upper case. In utils.js have a common function.
                  var topText = errorMap['<c:out value='${errorField}' escapeXml='false'/>'+'TopServerError']==undefined?"<c:out value='${errorField}' escapeXml='false'/>":errorMap['<c:out value='${errorField}' escapeXml='false'/>'+'TopServerError'];
			      //var errorMessage = "<c:out value='${bookingComponent.errorMessage}' escapeXml='false'/>";
                        var errorMessage = errorMap['<c:out value='${errorField}' escapeXml='false'/>'+'ServerError']==undefined?"Invalid <c:out value='${errorField}' escapeXml='false'/>":errorMap['<c:out value='${errorField}' escapeXml='false'/>'+'ServerError'];

			      var contentClass = $("."+errorField+"Error");
			      var errorName = errorField+ "Error";
				  var topContainer = $("#topError");
			      contentClass.addClass("formError");
                  $("<p class='formErrorMessage' id='"+errorName+"'>"+errorMessage+"</p>").prependTo(contentClass);
			      $("<li id='"+errorField+"TopError'>"+topText+"</li>").appendTo(topContainer);
               </c:if>
            </c:forTokens>
			</c:if>

            var form2 = $('form').webForm({
				onSubmitErrorDisplay: function(event, args){
				   commonSubmitBlurErrorDisplay(args);
				},
				onBlurErrorDisplay: function(event, args){
				   commonSubmitBlurErrorDisplay(args);
     			},
				onBlurSucessfulDisplay: function(event, args){			
					var field = jQuery(args[1]),
						fieldRow = field.closest('.row');
					console.log('args[1]:',args);
					if(args[1].value){
						fieldRow.find('.message').remove();
					  	fieldRow.removeClass("error valid").addClass('valid');
					}else{
						fieldRow.find('.message').remove();
						fieldRow.removeClass("error valid");
					}									   			  
     			},
				beforeSubmit: function(event, args){			    
					if($("."+ args +"Error #"+ args +"Error").length >1)
					{
			           $("#"+ args +"Error").remove();
					   $("#"+args+"TopError").remove();
					}
					if(args == "tourOperatorTermsAccepted" && $("#"+args).val()== 'true')
					{
					   console.log('its terms & condition',args);
					   //$("#"+ args +"Error").remove();
					   //$("#"+args+"TopError").remove();
					   $("#"+ args).closest('.row').removeClass('error');
					   $("#"+ args).closest('.row').find('.message').text('');
					}
				    if($("."+ args +"Error p.formErrorMessage").length < 1)
				       $("."+ args +"Error").removeClass("formError");

					if($("ul#topError li").length < 1)
					   $("#errorSummary").addClass("hide");
					$("#cardDetailsError").addClass("hide");
					forceRedraw();
				},
				beforeBlur: function(event, args){
					$("#"+ args +"Error").remove();
					if($("li ."+ args +"Error p.formErrorMessage").length < 1)
                       $("."+ args +"Error").removeClass("formError");
					$("."+ args +"Error").removeClass("formSucess");
					$("#"+args+"TopError").remove();
					if($("ul#topError li").length < 1)
					   $("#errorSummary").addClass("hide");
					forceRedraw();
				},
				onSubmitLuhnErrorDisplay: function(event)
				{
				   $("#cardDetailsError").removeClass("hide");
				   forceRedraw();
				},
				promoErrorDisplay: function(event,args)
				{
				   var id=args[0] + "Error";
				   if ($("#promoCodeSectionformErrorMessage"))
				   {
				     $("#promoCodeSection").removeClass("formError");
                     $("#promoCodeSectionformErrorMessage").addClass("hide");
				     $("#promoCodeSectionError").remove();
			         $("#promoCodeSectionTopError").remove();
				   }
				   if ($("#leadPassengerformErrorMessage"))
				   {
                     $("#leadPassenger").removeClass("formError");
                     $("#leadPassengerformErrorMessage").addClass("hide");
				     $("#leadPassengerError").remove();
			         $("#leadPassengerTopError").remove();
				   }
				   var topContainer = $("#topError");
				   $("#" + args[0]).addClass("formError");
				   var topText = 'Promotional Code';
				   var topContainer = $("#topError");
				   $("#errorSummary").removeClass("hide");
				   $("<p class='formErrorMessage' id='"+id+"'>"+args[1]+"</p>").prependTo($("#" + args[0]));
                   $("<li id='"+args[0]+"TopError'>"+topText+"</li>").appendTo(topContainer);
				   forceRedraw();

				   if (args[0] == 'leadPassenger')
				   {
				     $("#promoCodeSection").addClass("formError");
                     $("<p class='formErrorMessage' id='promoCodeSectionformErrorMessage'>"+'Please enter Lead Passenger Details'+"</p>").prependTo($("#promoCodeSection"));
				   }
			       $("#commonError").addClass("hide");

				},

				promoSuccessDisplay: function(event, args)
				{
				  if($("ul#topError li").length > 1)
				  {
					$("#promoCodeSectionError").remove();
				    $("#promoCodeSectionTopError").remove();
				    $("#leadPassengerError").remove();
			        $("#leadPassengerTopError").remove();
				  }
				  else
				  {
					$("#errorSummary").addClass("hide");
				  }
				  forceRedraw();
				  $("#promoCodeText").addClass('hide');
				  $("#promoCodeSection").addClass('hide');
				  $("#promoCodeSuccessSection").removeClass('hide');
				  $("#discountAmt").html(args[0]);
				}
			});



			for (var i = 0; i < Personaldetails.noOfPassengers; i++)
			{
				errorMap["surName_"+i+"BlurErroralpha"]= "Please enter a valid Surname";
                errorMap["foreName_"+i+"BlurErroralpha"]= "Please enter a valid First Name";
				errorMap["surName_"+i+"SubmitErrorrequired"]= "Please enter a Surname";
				errorMap["foreName_"+i+"SubmitErrorrequired"]= "Please enter a First Name";
				errorMap["passengerTitle"+i+"SubmitErrorrequired"]="Please select a Title";


            }
			$('form').webForm("addErrorMessage", errorMap);

    });


</script>


<%----------------------Payment fields used in scripting etc -----------------------------------------%>
<c:forEach var="cardCharge" items="${bookingComponent.cardChargesMap}">
  <c:out value='<input type="hidden" id="${cardCharge.key}_charge" value="${cardCharge.value} "/>' escapeXml='false'/>
</c:forEach>
<c:forEach var="paymentType" items="${bookingComponent.paymentType['CNP']}">
  <c:out value="<input type='hidden' value='${paymentType.paymentCode}_enabled'  id='${paymentType.paymentCode}_enabled' name='payment_code_${paymentType.paymentCode} '/>" escapeXml="false"/>
  <c:out value="<input type='hidden' value='${paymentType.cardType.isIssueNumberRequired}'  id='${paymentType.paymentCode}_issueNo' />" escapeXml="false"/>
  <c:out value="<input type='hidden' value='${paymentType.cardType.securityCodeLength}'  id='${paymentType.paymentCode}_securityCodeLength' />" escapeXml="false"/>
  <c:out value="<input type='hidden' value='${paymentType.cardType.minSecurityCodeLength}'  id='${paymentType.paymentCode}_minSecurityCodeLength' name='${paymentType.paymentCode}_minSecurityCodeLength'/>" escapeXml="false"/>
  <c:out value="<input type='hidden' value='${paymentType.cardType.isStartDateRequired}'  id='${paymentType.paymentCode}_startDateRequired' />" escapeXml="false"/>
</c:forEach>
<%-----------------*****END Payment fields used in scripting etc *****--------------------------------%>
